#!/usr/bin/perl

$n_args = @ARGV;
if (($n_args != 3)) {
    die "\n Usage: perl sequence_ordering.pl  <fastq of R1> <fastq of R2> <prefix for outputs>
 NOTE: quality scores are completely ignored. Do quality trim etc if needed.
 output files are prefix.RNS2.fa and prefix.GR.fa \n\n";
 }

# open fastq files
open (R1, $ARGV[0]); open (R2, $ARGV[1]);
$prefix=$ARGV[2];

#output file names
open (O_r18Sf, ">> $prefix.RNS2.fa"); open (O_Sym28Sr, ">> $prefix.GR.fa");

$c=0;#count read lines for fastq files
$seq_num=0;#put unique seq name
while($l1=<R1>){
  $l2=<R2>; # read R2 fastq
  chomp $l1; chomp $l2;
  $c++;
  if($c==1){
    $seq_num++;
    $l1=~s/\@//;$l2=~s/\@//; #remove header @
    $l1="s$seq_num\_1"; $l2="s$seq_num\_2";
    $n1=$l1; $n2=$l2; #sequence names
  }
  elsif($c==2){
    $s1=$l1; $s2=$l2; # sequences
  }
  elsif($c==4){ #print out in the last line (quality score)
     if($s1=~/CAGAGTAAGTCGTAACATAG|CTATGTTACGACTTACTCTG/){ #11bp of 3'end of RNS2
        #$n_18 =$n1; $s_18 =$s1;
        $n_18 =$n1; $s_18 =$';#マッチしたより後の配列
        if($s2=~/GTGTGTTCTCT|AGAGAACACAC/){ #check R2 has GR
          # $n_28 =$n2; $s_28 =$s2;
           $n_28 =$n2; $s_28 =$';
        }
     }
     elsif($s1=~/GTGTGTTCTCT|AGAGAACACAC/){#11bp of 3'end of GR
        #$n_28 =$n1; $s_28 =$s1;
        $n_28 =$n1; $s_28 =$';
        if($s2=~/CAGAGTAAGTCGTAACATAG|CTATGTTACGACTTACTCTG/){ #check R2 has RNS2 sequence
           #$n_18 =$n2; $s_18 =$s2;
           $n_18 =$n2; $s_18 =$';
        }
     }
     if(length ($s_18)>1 && length($s_28) >1){ #only print out when primers can be found in both reads
        print O_r18Sf ">$n_18\n$s_18\n";
        print O_Sym28Sr ">$n_28\n$s_28\n";
     }
     $c=0;
     $n_18='';$s_18='';$n_28 ='';$s_28 =''; #reset all values
  }
}

