#!/usr/bin/perl

$n_args = @ARGV;
if (($n_args != 3)) {
    die "\n Usage: perl sequence_ordering.pl  <fastq of R1> <fastq of R2> <prefix for outputs>
 NOTE: quality scores are completely ignored. Do quality trim etc if needed.
 output files are prefix.r18Sf.fa and prefix.Sym28Sr.fa \n\n";
 }

# open fastq files
open (R1, $ARGV[0]); open (R2, $ARGV[1]);
$prefix=$ARGV[2];

#output file names
open (O_r18Sf, ">> $prefix.r18Sf.fq"); open (O_Sym28Sr, ">> $prefix.Sym28Sr.fq");

$c=0;#count read lines for fastq files
$seq_num=0;#put unique seq name
while($l1=<R1>){
  $l2=<R2>; # read R2 fastq
  chomp $l1; chomp $l2;
  $c++;
  if($c==1){
    $seq_num++;
    $l1=~s/\@//;$l2=~s/\@//; #remove header @
    $l1="s$seq_num\_1"; $l2="s$seq_num\_2";
    $n1=$l1; $n2=$l2; #sequence names
  }
  elsif($c==2){
    $s1=$l1; $s2=$l2; # sequences
  }
  elsif($c==4){ #print out in the last line (quality score)
     if($s1=~/ATGAACCTTAT|ATAAGGTTCAT/){ #11bp of 3'end of r18Sf
        $n_18 =$n1; $s_18 =$s1;$q1=$l1;
        if($s2=~/ACTTCATGCTA|TAGCATGAAGT/){ #check R2 has Sym28Sr
           $n_28 =$n2; $s_28 =$s2;$q2=$l2;
        }
     }
     elsif($s1=~/ACTTCATGCTA|TAGCATGAAGT/){#11bp of 3'end of Sym28Sr
        $n_28 =$n1; $s_28 =$s1;$q2=$l1;
        if($s2=~/ATGAACCTTAT|ATAAGGTTCAT/){ #check R2 has r18Sf sequence
           $n_18 =$n2; $s_18 =$s2;$q1=$l2;
        }
     }
     if(length ($s_18)>1 && length($s_28) >1){ #only print out when primers can be found in both reads
        print O_r18Sf   "\@$n_18\n$s_18\n\+\n$q1\n";
        print O_Sym28Sr "\@$n_28\n$s_28\n\+\n$q2\n";
     }
     $c=0;
     $n_18='';$s_18='';$n_28 ='';$s_28 =''; #reset all values
  }
}

